package ihm;

import java.awt.Rectangle;
import java.io.Serializable;

public class SymbBounds implements Serializable {
   private int id;
   private int x = 0;
   private int y = 0;
   private int w = 0;
   private int h = 0;
   private boolean coords;
   
   public SymbBounds (Symbole symb) {
      Rectangle r = symb.getBounds();
      coords = true;
      id = symb.getID();
      x = (int)r.getX();
      y = (int)r.getY();
      w = (int)r.getWidth();
      h = (int)r.getHeight();
   }
   
   public SymbBounds (int sId, int sX, int sY, int sW, int sH) {
      coords = true;
      id = sId;
      x = sX;
      y = sY;
      w = sW;
      h = sH;
   }
   
   public SymbBounds (int sId) {
      coords = false;
      id = sId;
   }
   
   public int getId() {
      return id;
   }
   public int getX() {
      return x;
   }
   public int getY() {
      return y;
   }
   public int getW() {
      return w;
   }
   public int getH() {
      return h;
   }
   public boolean hasCoords() {
      return coords;
   }

}