package moteur;


import java.util.Vector;
import java.util.Iterator;

import reseau.Mib;

public class ElementReseau {

    private int id;
    private int type;
    private String nom;
    private String ipContact;
    private String community;
    //private Vector<String> interfaces;
    private Vector<Integer> elements;
    private boolean etat;


    //------------------------
    //constructeurs
    //------------------------
    public ElementReseau() {
        id = -1;
        type = 0;
        nom = "";
        //interfaces = null;
        ipContact = "";
        elements = null;
        etat = false;
        community = "public";
    }

    //------------------------
    //setteurs
    //------------------------

    public void setCommunity(String community)
    {
		this.community = community;
    }
    
    public void setIpContact(String ipContact)
    {
		this.ipContact = ipContact;
    }
    
    public void setId(int id){
        this.id = id;
    }

    public void setId(Integer id){
        this.id = id.intValue();
    }

    public void setType(int type){
        this.type = type;
    }

    public void setType(Integer type){
        this.type = type.intValue();
    }

    public void setNom(String nom){
        this.nom = new String(nom);
    }

	/*
    public void setInterfaces(Vector<String> interfaces){
        this.interfaces = new Vector<String>(interfaces);
    }

    //ajoute les interfaces sans redondence
    public void setInterfaces(String[] interfaces){
        if(interfaces != null && interfaces.length > 0)
        {
            this.interfaces = new Vector<String>();
            for (int i = 0; i < interfaces.length; i++)
            {
                if( ! containsInterface(interfaces[i]) )
                    this.interfaces.add(new String(interfaces[i]));
                else System.out.print("interface("+i+"] ignore => existe dj");
            }
        }
        else System.out.print("interfaces invalide => doit tre non null et de taille > 0");

    }
	*/
	
    public void setElements(Vector<Integer> elements){
        this.elements = new Vector<Integer>(elements);
    }

    //ajoute les elements sans redondence
    public void setElements(int[] elements){
        if(elements != null && elements.length > 0)
        {
            this.elements = new Vector<Integer>();
            for(int i=0; i < elements.length; i++)
            {
                if( !containsElement(elements[i]) )
                    this.elements.add(new Integer(elements[i]));
                else System.out.print("elements("+i+"] ignor => existe dj");
            }
        }
        else System.out.print("elements invalide => doit tre non null et de taille > 0");
    }

    //ajoute les elements sans redondence
    public void setElements(Object[] elements){
        if(elements != null && elements.length > 0)
        {
            this.elements = new Vector<Integer>();
            for (int i = 0; i < elements.length; i++)
            {
                 if( elements[i] instanceof Integer )
                 {
                     if (!containsElement((Integer) elements[i]))
                         this.elements.add( new Integer( ((Integer) elements[i]) ) );
                     else System.out.print("elements(" + i +"] ignor => existe dj");
                 }
                 else
                 if( elements[i] instanceof ElementReseau )
                 {
                     if (!containsElement((ElementReseau) elements[i]))
                         this.elements.add(new Integer( ((ElementReseau) elements[i]).getIntegerId() ));
                     else System.out.print("elements(" + i + "] ignor => existe dj");
                 }
                 else System.out.print("elements(" + i + "] invalide => doit tre de type ElementReseau, Integer ou int");
            }
        }
        else System.out.print("elements invalide => doit tre non null et de taille > 0");
    }



    public void setEtat(boolean etat)
    {
        this.etat = etat;
    }


    //------------------------
    //getteur
    //------------------------

    public String getCommunity(){
		return this.community;
    }
    
    public int getId(){
       return this.id;
   }

    public Integer getIntegerId(){
        return new Integer(this.id);
    }

    public int getType(){
       return this.type;
   }

    public Integer getIntegerType(){
        return new Integer(this.type);
    }

    public String getNom(){
        return this.nom;
    }

    public Vector<Integer> getElements(){
        return this.elements;
    }

    //retourne les elements dans un tableau d'Integer
    public Integer[] getIntegerArrayElements(){
        return (Integer [])this.elements.toArray();
    }

    //retourne les elements dans un tableau d'int
    public int[] getArrayElements(){
        int [] temp = new int[nbElements()];
        Iterator it = this.elements.iterator();
        int i = 0;
        while(it.hasNext())
        {
            temp[i] = ((Integer)it.next()).intValue();
            i++;
        }
        return temp;
    }

	public String getIpContact()
	{
		return this.ipContact;
	}
	
	/*
    public Vector<String> getInterfaces(){
        return this.interfaces;
    }

    //retourne les interfaces dans un tableau de String
    public String[] getArrayInterfaces(){
        return (String [])this.interfaces.toArray();
    }
	*/

    public boolean getEtat() {
        return this.etat;
    }

    public Boolean getBooleanEtat(){
        return new Boolean(this.etat);
    }


    //------------------------
    //methodes
    //------------------------
    public String toString(){
        String s = "";
        s = s + "id: "+this.id;
        s = s + "\ntype: "+this.type;
        s = s + "\nnom: "+this.nom;
        s = s + "\ncommnunity: "+this.community;
        /*
        if(this.interfaces != null)
        {
            Iterator it = this.interfaces.iterator();
            while(it.hasNext())
            {
                s = s + "\ninterface : "+(String)it.next();
            }
        }
        else s = s + "\npas d'interface";
		*/
		s = s + "\nipContact: " + this.ipContact;
		
        if(this.elements != null)
        {
            Iterator it = this.elements.iterator();
            while(it.hasNext())
            {
                s = s + "\nelement : "+((Integer)it.next()).toString();
            }
        }
        else s = s + "\npas d'element";

        if(this.etat) s = s +"\nELEMENT ACTIF";
        else s = s + "\nELEMENT INACTIF";
        return s;
    }

    public boolean equals(Object o){
        if(o instanceof ElementReseau)
        {
            if( getId() == (((ElementReseau)o).getId()) && getType() == (((ElementReseau)o).getType()) && getNom().equals(((ElementReseau)o).getNom()) && getIpContact().equals((((ElementReseau)o).getIpContact())) && getCommunity().equals((((ElementReseau)o).getCommunity())))
            {
                if(nbElements() == ((ElementReseau)o).nbElements() )
                {
                    for(int i = 0; i <nbElements() ; i ++) if( getIntegerElement(i).equals(((ElementReseau)o).getIntegerElement(i)) ) return false;
                    //for(int i = 0; i <nbInterfaces() ; i ++) if( getInterface(i).equals(((ElementReseau)o).getInterface(i)) ) return false;
                    return true;
                }
                else return false;
            }
            else return false;
        }
        else return false;

    }

	/*
    public int nbInterfaces(){
        if(this.interfaces == null) return -1;
        else return this.interfaces.size();
    }
	*/
	
    public int nbElements(){
        if(this.elements == null) return -1;
        else return this.elements.size();
    }

	/*
    //retourne la premiere interface dans un String
    public String getFirstInterface(){
        return (String)this.interfaces.firstElement();
    }


    //retourne la derniere interface dans un String
    public String getLastInterface(){
        return (String)this.interfaces.lastElement();
    }


    //creer un iterateur sur les interfaces
    public Iterator<String> getInterfacesIterator(){
        return (Iterator<String>)this.interfaces.iterator();
    }

    //retourne l'interface  l'index dans un Ip
    public String getInterface(int index)
    {
        if(nbInterfaces() > 0 && index < nbInterfaces() && index >= 0) return (String)this.interfaces.get(index);
        else return null;
    }
	*/
	
	
    //retourne le premier element dans un Integer
    public Integer getFirstIntegerElement(){
        return (Integer)this.elements.firstElement();
    }

    //retourne le premier element dans un int
    public int getFirstElement(){
        return ((Integer) this.elements.firstElement()).intValue();
    }

    //retourne le dernier element dans un Integer
    public Integer getLastIntegerElement(){
        return (Integer) this.elements.lastElement();
    }

    //retourne le dernier element dans un int
    public int getLastElement(){
        return ((Integer) this.elements.lastElement()).intValue();
    }

    //creer un iterateur sur les elements
    public Iterator<Integer> getElementsIterator(){
        return (Iterator<Integer>)this.elements.iterator();
    }

    //retourne l'element  l'index dans un Integer
    public Integer getIntegerElement(int index)
    {
        if(nbElements() > 0 && index < nbElements() && index >= 0) return (Integer)this.elements.get(index);
        else return null;
    }

    //retourne l'element  l'index dans un int
    public int getElement(int index)
    {
        if(nbElements() > 0 && index < nbElements() && index >= 0) return ((Integer) this.elements.get(index)).intValue();
        else return -1;
    }


    public boolean isActif()
    {
        return getEtat();
    }

    //rinitialise l'etat  inactif
    public void resetEtat(){
        setEtat(false);
    }


    public boolean containsElement(int idElement)
    {
        if(nbElements() <= 0) return false;
        return this.elements.contains(new Integer(idElement));
    }

    public boolean containsElement(Object element)
    {
        if(nbElements() <= 0) return false;
        if(element != null)
        {
            if(element instanceof ElementReseau)return this.elements.contains(((ElementReseau)element).getIntegerId());
            else if(element instanceof Integer)return this.elements.contains((Integer)element);
            else return false;
        }
        else return false;
    }

	/*
    public boolean containsInterface(String interf)
    {
        if(nbInterfaces() <= 0) return false;
        if(interf != null)
        {
            return this.interfaces.contains(interf);
        }
        else return false;
    }

    public int indexOfInterface(String interf)
    {
        if (nbInterfaces() <= 0)return -1;
        if (interf != null) {
            Iterator it = this.interfaces.iterator();
            int i = 0;
            while (it.hasNext())
            {
                if (((String) it.next()).equals(interf))return i;
                i++;
            }
        }

        return -1;
    }
	*/
	
    public int indexOfElement(Integer id)
    {
        if (nbElements() <= 0)return -1;
        if (id != null) {
            Iterator it = this.elements.iterator();
            int i = 0;
            while (it.hasNext())
            {
                if (((Integer) it.next()).equals(id))return i;
                i++;
            }
        }

        return -1;
    }

    public int indexOfElement(int id)
    {
        return indexOfElement(new Integer(id));
    }


    //ajoute un element sans redondence
    public void addElement(int element){
        if(element >= 0)
        {
            if( ! containsElement(element))
            {
                if( nbElements() <= 0 ) this.elements = new Vector<Integer>();
                this.elements.add(new Integer(element));
            }
        }
        else
        {
            System.out.println("identifiant invalide => doit tre positif ou 0");
        }
    }

    //ajoute un element sans redondence
    public void addElement(Object element){
        if(element != null)
        {
            if (element instanceof ElementReseau)
            {
                if( ! containsElement((ElementReseau)element) )
                {
                    if( nbElements() <= 0 )
                        this.elements = new Vector<Integer>();
                    this.elements.add( new Integer(((ElementReseau)element).getIntegerId()) );
                }
                
            }
            else if (element instanceof Integer)
            {
                if( ! containsElement((Integer)element) )
                {
                    if( nbElements() <= 0 )
                        this.elements = new Vector<Integer>();
                    this.elements.add( new Integer((Integer)element) );
                }
                
            }
            else
            {
                 System.out.println("element invalide => doit tre de type ElementReseau, Integer ou int");
            }
        }
        else
        {
            System.out.println("element invalide => doit tre non null");
        }
    }
	
    //ajoute un tableau d'identifiant sans redondence
    public void addElements(int[] idElements)
    {
        for(int i = 0; i<idElements.length; i++) addElement(idElements[i]);
    }

    //ajoute un tableau d'identifiant sans redondence
    public void addElements(Object[] elements)
    {
        for(int i = 0; i<elements.length; i++) addElement(elements[i]);
    }

    //place un element  l'index sans redondence
    public void setElement(int element, int index )
    {
        if(index >= 0 && index < nbElements())
        {
            if (!containsElement(element))
                this.elements.setElementAt(new Integer(element), index);
        }
        else System.out.println("index invalide");
    }

    //place un element  l'index sans redondence
    public void setElement(Object element, int index )
    {
        if(element != null)
        {
            if(index >= 0 && index < nbElements())
            {
                if (element instanceof ElementReseau) {
                    if (!containsElement((ElementReseau) element))
                        this.elements.setElementAt(new Integer(((ElementReseau) element).getIntegerId()), index);
                    
                }
                else if (element instanceof Integer) {
                    if (!containsElement((Integer) element))
                        this.elements.setElementAt(new Integer((Integer) element), index);
                    
                }
                else System.out.println("element invalide => doit tre de type ElementReseau, Integer ou int");
            }
            else System.out.println("index invalide");
        }
        else System.out.println("element invalide => doit tre non null");
    }


	
    //supprime l'element  l'index
    public void removeElementAt(int index)
    {
        if(index >= 0 && index < nbElements())
        {
            this.elements.removeElementAt(index);
        }
        else System.out.println("index invalide");
    }

	
    //supprime l'element
    public void removeElement(Object element)
    {
        if(element != null)
        {
            if (element instanceof ElementReseau) this.elements.remove(((ElementReseau)element).getIntegerId());
            else if (element instanceof Integer) this.elements.remove((Integer) element);
            else System.out.println("element invalide => doit tre de type ElementReseau, Integer, ou int");
        }
        else System.out.println("element invalide => doit tre non null");
    }

    //supprime l'element
    public void removeElement(int idElement)
    {
        this.elements.remove(new Integer(idElement));
    }

	
    public ElementReseau clone()
    {
        ElementReseau e = new ElementReseau();
        e.setId(this.getId());
        e.setType(this.getType());
        e.setNom(this.getNom());
        e.setElements(this.getElements());
        e.setIpContact(this.getIpContact());
        e.setCommunity(this.getCommunity());
        e.setEtat(this.getEtat());
        return e;
    }


    public java.util.Hashtable<String, String[]> getAll(){
        java.util.Hashtable<String, String[]> v = new java.util.Hashtable<String, String[]>();
        String [] stemp = new String[3];
        stemp[0] = ((Integer)Mib.ACCESS_RO).toString();
        stemp[1] = ((Integer)this.getId()).toString();
        stemp[2] = "";
        v.put("id",stemp);

        stemp = new String[3];
        stemp[0] = ((Integer)Mib.ACCESS_RW).toString();
        stemp[1] = this.getNom();
        stemp[2] = "";
        v.put("nom",stemp);


        stemp = new String[3];
        stemp[0] = ((Integer)Mib.ACCESS_RW).toString();
        stemp[1] = ((Integer)this.getType()).toString();
        stemp[2] = "";
        v.put("type",stemp);

        stemp = new String[3];
        stemp[0] = ((Integer)Mib.ACCESS_RW).toString();
        stemp[1] = this.community;
        stemp[2] = "";
        v.put("community",stemp);
               
		stemp = new String[3];
		stemp[0] = ((Integer) Mib.ACCESS_RW).toString();
        stemp[1] = this.ipContact;
        stemp[2] = "";
        v.put("ipContact", stemp);

        if(this.elements != null)
        {
            int i =1;
            Iterator it = this.getElementsIterator();
            while(it.hasNext())
            {
                stemp = new String[3];
                stemp[0] = ((Integer)Mib.ACCESS_RW).toString();
                stemp[1] = ((Integer) it.next()).toString();
                stemp[2] = "";
                if(i <= 1)
                    v.put("element", stemp);
                else
                    v.put("element("+i+")", stemp);
                i++;
            }
        }

        stemp = new String[3];
        stemp[0] = ((Integer)Mib.ACCESS_RO).toString();
        stemp[1] = ((Boolean)this.getEtat()).toString();
        stemp[2] = "";
        v.put("etat",stemp);

        return v;
    }
}
