package moteur;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Iterator;
import java.util.Enumeration;

/**
 * <p>Titre : </p>
 *
 * <p>Description : </p>
 *
 * <p>Copyright : Copyright (c) 2006</p>
 *
 * <p>Socit : </p>
 *
 * @author non attribuable
 * @version 1.0
 */
public class ElementReseauConfiguration implements java.io.Serializable{

    static final long serialVersionUID = 1L;

    private Hashtable<String, String[]> base;
    private Hashtable<String, String[]> perso;

    //-----
    // constructeur
    //-----
    public ElementReseauConfiguration() {
        base= new Hashtable();
        perso = new Hashtable();
    }

    //-----
    // setteur
    //-----

    public void setBase(Hashtable<String, String[]> base){
        if(base != null)
            this.base = new Hashtable<String,String[]>(base);
        else
            this.base = null;
    }

    public void setPerso(Hashtable<String, String[]> perso){
        if(perso != null)
            this.perso = new Hashtable<String,String[]>(perso);
        else
            this.perso = null;
    }


    //-----
    // getteur
    //-----

    public Hashtable<String, String[]> getBase(){
        return this.base;
    }

    public Hashtable<String, String[]> getPerso(){
        return this.perso;
    }

    //-----
    // methodes
    //-----

    public int nbBase()
    {
        if(this.base == null) return -1;
        else return this.base.size();
    }

    public int nbPerso()
    {
        if(this.perso == null) return -1;
        else return this.perso.size();
    }


    //retourne l'objet  la cl key
    public String[] getElementBase(String key){
        return (String[])this.base.get(key);
    }

    public String[] getElementPerso(String key){
        return (String[])this.perso.get(key);
    }

    //ajoute le couple key/value sans redondence
    public void addElementBase(String key, String[] value){

        if(base != null)
        {
            if (this.base.containsKey(key)) 
            {
                String[] v = (String[])this.base.get(key);
                if(key.equals("nom") || key.equals("ipContact") || key.equals("community"))
                {
					this.base.put(key, value);
                }
                else
                {
                    
					java.util.StringTokenizer st = new java.util.StringTokenizer(key,"()");
                    String keyTemp = st.nextToken();
                    String number = "";
                    if(st.hasMoreTokens())
                        number = st.nextToken();
                    int i = 1;
                    if (!number.equals(""))
                        i = Integer.parseInt(number);
                    i++;
                    keyTemp = keyTemp +"("+ i +")";
                    addElementBase(keyTemp,value);
                }
            } 
            else 
            {
                this.base.put(key, value);
            }
        }
        else
        {
            this.base = new Hashtable<String,String[]>();
            this.base.put(key, value);
        }
    }


    public void addElementPerso(String key, String[] value){

        if(this.perso != null)
        {
            if (this.perso.containsKey(key)) {
                String[] v = (String[])this.perso.get(key);
                if (v[0].equals(value[0]) && v[1].equals(value[1]) &&
                    v[2].equals(value[2])) {
                } else {
                    java.util.StringTokenizer st = new java.util.StringTokenizer(key,
                            "()");
                    String keyTemp = st.nextToken();
                    String number = "";
                    if(st.hasMoreTokens())
                        number = number + st.nextElement();
                    int i = 0;
                    if (!number.equals(""))
                        i = Integer.parseInt(number);
                    i++;
                    keyTemp = keyTemp +"("+ i +")";
                    addElementPerso(keyTemp,value);
                }
            } else {
                this.perso.put(key, value);
            }
        }
        else
        {
            this.perso = new Hashtable<String,String[]>();
            this.perso.put(key, value);
        }

    }

    //suprime les proprietes referencees par la cl key
    public void removeElementBase(String key){
            if(this.base != null)this.base.remove(key);
    }

    //suprime les proprietes referencees par la cl key
    public void removeElementPerso(String key){
            if(this.perso != null)this.perso.remove(key);
    }

    //place le couple key/value
    public void setElementBase(String key, String[] value)
    {
        if(this.base == null) this.base = new Hashtable<String,String[]>();
        this.base.put(key,value);
    }

    public void setElementPerso(String key, String[] value)
    {
        if(this.perso == null) this.perso = new Hashtable<String,String[]>();
        this.perso.put(key,value);
    }



    //initilaise les propriete a partir d'un ELementReseau
    public void setElementReseau(ElementReseau element)
    {
        if(this.base == null) this.base = new Hashtable<String,String[]>();
        Hashtable <String, String []> tempBase = this.base;
        Hashtable <String, String []> tempElem = element.getAll();
        Enumeration<String> enumBase = (Enumeration<String>)tempBase.keys();
        while(enumBase.hasMoreElements())
        {
            String key = (String)enumBase.nextElement();
            if( !key.startsWith("element")
                && !key.startsWith("ipContact")
                && !key.startsWith("type")
                && !key.startsWith("id")
                && !key.startsWith("nom")
				&& !key.startsWith("community")
                && !key.startsWith("etat"))
            {
                tempElem.put(key,(String[])tempBase.get(key));
            }

        }


        setBase(tempElem);
    }


    public String toString(){
        String s = "";
        if(base != null)
        {
            s = s +"\nBASE:";
            java.util.Enumeration e = base.keys();
            while (e.hasMoreElements()) {
                String key = (String) e.nextElement();
                String[] v = (String[]) base.get(key);
                s = s + "\n" + key + "-> valeur:" + v[1] + ", codeMIB:" + v[2] +
                    ", modifiable:" + v[0];
            }
        }
        if(perso != null)
       {
           s = s +"\nPERSO:";
           java.util.Enumeration e = perso.keys();
           while (e.hasMoreElements()) {
               String key = (String) e.nextElement();
               String[] v = (String[]) perso.get(key);
               s = s + "\n" + key + "-> valeur:" + v[1] + ", codeMIB:" + v[2] +
                   ", modifiable:" + v[0];
           }
       }

        return s;
    }

}
