package moteur;

import java.util.Date;

/**
 * L'interface Moteur - Rseau.
 * <p>
 * Cette inerface prsente les quelques mthodes que doit
 * implmenter la classe du moteur qui sera visible par le rseau.
 * </p>
 * @author      M2SSI SNMP
 * @version     %I%, %G%
 * @since       1.0
 */
public interface MoteurReseau {

/**
 * <p>Prvient le moteur de l'arrive d'une alerte.</p>
 * <p> Lorsque le rseau reoit une alerte en SNMP, il la transmet au moteur
 * par l'intermdiaire de cette fonction. </p>
 *
 * @param ip l'IP de l'lment qui a mit l'alerte
 * @param message le message associ  l'alerte
 * @param oid l'oid associ  l'alerte
 * @param time la date exacte de la rcption de l'alerte
 * @param err1 code d'erreur 1
 * @param err2 code d'erreur 2
 */
    public void setAlert(String ip, String message, String oid, Date time, int err1, int err2);

}
