package moteur;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;

import javax.xml.parsers.*;

import moteur.*;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXParseException;

public class ReseauHandler extends DefaultHandler{

   private Reseau reseau;
   private ElementReseau element;


   private boolean inreseau, inelements, inipcontact, incommunity, inautres, inpc,inrouteur, inimprimante,inswitch,inserveur, inhub, inid, ininterfaces, inadresse, innom;
   private boolean isValid;
   private boolean test;
   //------------------------
   //constructeurs
   //------------------------

   public ReseauHandler(){
      super();
      isValid = true;
      test = false;

   }

   //------------------------
   //setteurs
   //------------------------

   //------------------------
   //getteurs
   //------------------------

   //------------------------
   //methodes
   //------------------------

   //dtection d'ouverture de balise
   public void startElement(String uri,
                         String localName,
                         String qName,
                         Attributes attributes)
                  throws SAXException{
      qName = qName.toLowerCase();
      if(qName.equals("reseau")){
         reseau = new Reseau();
         inreseau = true;
     }else if(qName.equals("autres")){
        element = new ElementReseau();
        element.setType(ET.OTHER);
         inautres = true;
      }else if(qName.equals("pc")){
         element = new ElementReseau();
         element.setType(ET.PC);
         inpc = true;
     }else if(qName.equals("routeur")){
        element = new ElementReseau();
        element.setType(ET.ROUTER);
         inrouteur = true;
     }else if(qName.equals("imprimante")){
        element = new ElementReseau();
        element.setType(ET.PRINTER);
         inimprimante = true;
     }else if(qName.equals("switch")){
        element = new ElementReseau();
        element.setType(ET.SWITCH);
         inswitch = true;
     }else if(qName.equals("serveur")){
        element = new ElementReseau();
        element.setType(ET.SERVER);
         inserveur = true;
      }else if(qName.equals("hub")){
          element = new ElementReseau();
          element.setType(ET.HUB);
          inhub = true;
      }
      else if(qName.equals("elements")){
                inelements = true;
      }
      else if(qName.equals("ipcontact")){
                inipcontact = true;
      }
      else if(qName.equals("community")){
                incommunity = true;
      }
      else if(qName.equals("id")){
                inid = true;
                test =false;
      }
      else if(qName.equals("nom")){
                innom = true;
                test =false;
      }
      else{
         //erreur, on peut lever une exception
         //throw new SAXException("Balise "+qName+" inconnue.");
         isValid = false;
      }
   }

   //dtection fin de balise
   public void endElement(String uri,
                       String localName,
                       String qName)
                throws SAXException{
      qName = qName.toLowerCase();
      if(qName.equals("reseau")){
         inreseau = false;
     }else if(qName.equals("autres")){
         reseau.addElement(element);
         inautres = false;
     }else if(qName.equals("pc")){
         reseau.addElement(element);
         inpc = false;
     }else if(qName.equals("routeur")){
         reseau.addElement(element);
         inrouteur = false;
     }else if(qName.equals("imprimante")){
         reseau.addElement(element);
         inimprimante= false;
     }else if(qName.equals("switch")){
         reseau.addElement(element);
         inswitch = false;
     }else if(qName.equals("serveur")){
         reseau.addElement(element);
         inserveur = false;
     }else if(qName.equals("hub")){
         reseau.addElement(element);
         inhub = false;
     }else if(qName.equals("elements")){
         inelements = false;
     }else if(qName.equals("ipcontact")){
         inipcontact = false;
         if(!test) isValid = false;
     }else if(qName.equals("community")){
         incommunity = false;
         if(!test) isValid = false;
     }else if(qName.equals("id")){
         inid = false;
         if(!test) isValid = false;
     }else if(qName.equals("nom")){
         innom = false;
         if(!test) isValid = false;
     }else{
         isValid = false;
     }
 }

  //dtection de caractres
  public void characters(char[] ch,
                         int start,
                         int length)
          throws SAXException{
      String lecture = new String(ch,start,length);
      test = true;
      if(inid && !inelements )
      {
          try
          {
              int id = Integer.parseInt(lecture);
              element.setId(id);
          }
          catch (Exception e){isValid = false;}
      }

      if(inid && inelements)
      {
          try
          {
              int id = Integer.parseInt(lecture);
              element.addElement(id);
          } catch (Exception e){isValid = false;}
      }
      if(innom)
      {
          element.setNom(lecture);
      }
      if(inipcontact)
      {
          element.setIpContact(lecture);
      }
      if(incommunity)
      {
          element.setCommunity(lecture);
      }
  }

  //dbut du parsing
  public void startDocument() throws SAXException {
  }

  //fin du parsing
  public void endDocument() throws SAXException {
  }


  public Reseau getReseau(){
      return reseau;
  }



  public boolean isValid(){
      return isValid;
  }

  //gestion de la dtd
  public InputSource resolveEntity(String publicId, String systemId) throws
          SAXException {
      try {
          if (!systemId.startsWith("file:")) {
              return null;
          }
          String pathDtd = systemId.substring(5);
          if (!pathDtd.startsWith("/")) {
              pathDtd = "/" + pathDtd;
          }
          InputStream is = getClass().getResourceAsStream(pathDtd);
          if (null == is) {
              return null;
          }
          return new InputSource(is);
      } catch (Exception e) {
          return null;
      }
  }


}
