package reseau;

public class TypeInteger extends Type {
	private long	value;
	
	public TypeInteger (int l) {
		super(Type.INTEGER, l);
		value = 0;
		updateContent();
	}

	public TypeInteger (long v, int l) {
		super(Type.INTEGER, l);
		value = v;
		updateContent();
	}
	
	public TypeInteger (byte t, long v, int l) {
		super(t, l);
		value = v;
		updateContent();
	}
	
	public TypeInteger (byte t, int len, byte tab[]) {
		super(t, len);
		value = 0;
		int	p = 1;
		for (int i=len-1; i>=0; i--) {
			if (tab[i] >= 0) {
				value += tab[i] * p;
			} else {
				value += (tab[i]+256) * p;
			}
			
			p *= 256;
		}
		content = tab;
	}
	
	public long getValue() {
		return value;
	}
	
	public void setValue(long v) {
		value = v;
		updateContent();
	}
	
	protected void updateContent() {
		long r = 0;
		int n = 1;
		long v = 0;

		content = new byte[length];
		v = value;
	
		for (int i=length-1; i>=0; i--) {
			/*n *= 256;
			r = v/256;
			content[i] = (byte)(v - r*256);
			v = r;*/
			content[i] = (byte)(v%256);
			v = v/256;
		}
	}
	
	public String toString() {
		return "" + value;
	}
	
	public boolean fromString(String s) {
		try {
			value = Long.parseLong(s);
			return true;
		} catch (NumberFormatException e) {
			return false;
		}
	}
}
