package reseau;

import java.util.StringTokenizer;

public class TypeIpAddress extends Type {
	private int	values[];

	public TypeIpAddress () {
		super (Type.IPADDRESS, 4);
		values = new int[4];
		values[0] = 0;
		values[1] = 0;
		values[2] = 0;
		values[3] = 0;
		updateContent();
	}
	
	public TypeIpAddress(String s) {
		super (Type.IPADDRESS, 4);
		values = new int[4];
		values[0] = 0;
		values[1] = 0;
		values[2] = 0;
		values[3] = 0;
		fromString(s);
	}
	
	public TypeIpAddress(int len, byte tab[]) {
		super (Type.IPADDRESS, 4);
		values = new int[4];
		
		if (tab[0] < 0)
			values[0] = (int)tab[0] + 256;
		else
			values[0] = (int)tab[0];
			
		if (tab[1] < 0)
			values[1] = (int)tab[1] + 256;
		else
			values[1] = (int)tab[1];
		
		if (tab[2] < 0)
			values[2] = (int)tab[2] + 256;
		else
			values[2] = (int)tab[2];
		
		if (tab[3] < 0)
			values[3] = (int)tab[3] + 256;
		else
			values[3] = (int)tab[3];
		content = tab;
	}
	
	public boolean fromString(String s) {
		StringTokenizer	tok = new StringTokenizer(s);
		int				i = 0;
		
		while (tok.hasMoreTokens() && i < 4) {
			values[i] = Integer.parseInt(tok.nextToken());
			i++;
		}
		
		updateContent();
		
		if (i<4)
			return false;
		else
			return true;
	}
	
	public String toString() {
		return "" + values[0] + "." + values[1] + "." + values[2] + "." + values[3];
	}
	
	protected void updateContent() {
		content = new byte[4];
		content[0] = (byte)values[0];
		content[1] = (byte)values[1];
		content[2] = (byte)values[2];
		content[3] = (byte)values[3];
	}
}
