package reseau;

import java.util.Iterator;
import java.util.Vector;

public class TypeSequence extends Type {
	private Vector<Type>	v;
	
	public TypeSequence() {
		super(Type.SEQUENCE, 0);
		v = new Vector<Type>();
	}
	
	public TypeSequence (int l, byte tab[], int isos) {
		super(Type.SEQUENCE, l);
		v = new Vector<Type>();
		int i = 0;
		
		//System.out.println("TypeSequence profondeur " + isos);
		
		//System.out.println("Sequence de longueur " + l);
		while (i < l) {
			byte	type = tab[i];
			int		len=0, n=0;
			byte	newtab[];
			
			//System.out.println("Traitage d'un element de type " + type);
		
			if (tab[i+1] >= 0) {
				n = 0;
				len = tab[i+1];
			} else {
				n = tab[i+1] + 128;
				int p = 1;
				for (int j=n; j>0; j--) {
					if (tab[i+j+1] < 0) {
						len += (tab[i+j+1] + 256) * p;
					} else {
						len += tab[i+j+1] * p;
					}
					p *= 256;
				}
			}
			
			//System.out.println("len = " + len);
			//System.out.println("i = " + i);
			//System.out.println("n = " + n);
			
			newtab = new byte[len+n+2];
			for (int j=0; j<len+n+2; j++) {
				//System.out.println("newtab["+j+"]="+Integer.toHexString(tab[i+j]));
				newtab[j] = tab[i+j];
			}
			
			//System.out.println("Ajout d'un element de longueur " + len);
			
			add (Type.typeFromBytes(newtab, isos));
			i += len+n+2;
			//System.out.println("Nouvelle valeur de i : " + i);
		}
		//System.out.println("Sequence cree : " + v.size());
		
		//System.out.println(this);
	}
	
	public void add (Type t) {
		//System.out.println("add : " + t);
		v.add(t);
		updateContent();
	}
	
	public int size() {
		return v.size();
	}
	
	public Type get (int index) {
		return v.get(index);
	}
	
	protected void updateContent() {
		int	size = 0, k = 0;
		
		for (int i=0; i<v.size(); i++) {
			size += ((Type)v.elementAt(i)).length + 2;
		}
		
		length = size;
		
		content = new byte[length];
		
		for (int i=0; i<v.size(); i++) {
			Type t = (Type)v.elementAt(i);

			for (int j=0; j<t.length+2; j++) {
				content[k++] = t.getBytes()[j];
			}
		}
	}
	
	public String toString() {
		Iterator<Type>	i = v.iterator();
		String 			s = "[ ";
		
		while (i.hasNext()) {
			s += i.next().toString() + " ";
		}
		s += "]";
		
		return s;
	}
	
	public boolean fromString(String s) {
		return true;
	}
}
